function [x,iter,stimaerrore] = jacobi(A,b,x,tol,maxit)
%
% [x,iter,stimaerrore] = jacobi(A,b,x,tol,maxit)
%
n = length(A);
D = spdiags(diag(A),0,n,n);
P = D\[D-A,b];
g = P(:,n+1);
B = P(:,1:n);
x0 = x;
iter = 0;
stimaerrore = tol+1;
while ((stimaerrore > tol) & (iter < maxit))
  x = B*x0+g;
  iter = iter+1;
  stimaerrore = norm(x-x0);
  x0 = x;
end 
if (stimaerrore > tol)
  warning('Impossibile raggiungere la tolleranza richiesta')
  warning('entro il numero massimo di iterazioni consentito.')
end
